Subject: bug#30066: 'get-bytevector-some' returns only 1 byte from unbuffered ports

From: [email-masked] (Ludovic Courtès)
Date: Fri, 12 Jan 2018 11:15:08 +0100

Andy Wingo <[email-masked]> skribis:

> On Thu 11 Jan 2018 22:55, Mark H Weaver <[email-masked]> writes:

[...]

>>>> Out of curiosity, is there a reason why you're using an unbuffered port
>>>> in your use case?
>>>
>>> It’s to implement redirect à la socat:
>>>
>>>   https://git.savannah.gnu.org/cgit/guix.git/commit/?id=17af5d51de7c40756a4a39d336f81681de2ba447
>>
>> Why is an unbuffered port being used here?  Can we change it to a
>> buffered port?
>
> This was also a question I had!  If you make it a buffered port at 4096
> bytes (for example), then get-bytevector-some works exactly like you
> want it to, no?

It might work, but that’s more by chance no?

I mean, if we declare the port as buffered, then we give the I/O
routines the “right” to fill in that buffer.

WDYT?

Thanks,
Ludo’.